class Interval
{
  float min;
  float max;
  
  Interval(float Min, float Max)
  {
    min = Min;
    max = Max;
  }
  
  void insert(float value)
  {
    if (value > max)
    {
      max = value;
    }
    else if (value < min)
    {
      min = value;
    }
  }
  
  Interval offset(float k)
  {
    Interval R = new Interval(0,0);
    R.min = min+k;
    R.max = max+k;
    return R;
  }
  
  Interval intersect(Interval I)
  {
    Interval R;
    
    if ((min <= I.max && min >= I.min) || (I.min <= max && I.min >= min))
    {
      if ( min > I.min )
      {
        R = new Interval(min,I.max);
      }
      else
      {
        R = new Interval(I.min,max);
      }
    }
    else
    {
      R = new Interval(0,0);
    }
    
    return R;
  }
  
  float length()
  {
    return max-min;
  }
}
