class MouseController
{
  Pointer mouse;
  Pointer mouseWeld;
  Pointer object;
  Pointer objectWeld;
  
  MouseController()
  {
    mouse = WORLD.addObject(pix2met(-10),pix2met(-10),fixed,new Polygon(4).scale(pix2met(1),pix2met(1)));
    mouseWeld = WORLD.addWeldPoint(mouse,new Point(0,0));
    WORLD.addColBlackList(mouse, new Pointer(-1));
  }
  
  void pressed()
  {
    WORLD.setPosition(mouse, new Point(pix2met(mouseX), pix2met(mouseY)));
    object = WORLD.getObjAt(new Point(pix2met(mouseX), pix2met(mouseY)));
    
    if (object.index != -1)
    {
      objectWeld = WORLD.addWeldPoint(object,new Point(pix2met(mouseX)-WORLD.objects[object.index].center.x,pix2met(mouseY)-WORLD.objects[object.index].center.y));

      WORLD.addLink(mouse,mouseWeld,object,objectWeld,pix2met(50),50000);
    }
  }
  
  void dragged()
  {
    if (object.index != -1)
    {
      WORLD.setPosition(mouse, new Point(pix2met(mouseX), pix2met(mouseY)));
    }
  }
  
  void released()
  {
    WORLD.setPosition(mouse, new Point(pix2met(-10), pix2met(-10)));
    if (object.index != -1)
    {
      WORLD.popLink();
      WORLD.popWeld(object);
    }
  }
}
