class Point
{
  float x;
  float y;
  
  Point()
  {
    x = 0;
    y = 0;
  }
  
  Point(float X, float Y)
  {
    x = X;
    y = Y;
  }
  
  Point addVector(Vector V)
  {    
    Point R = new Point();
    R.x = x+V.getCoords().x;
    R.y = y+V.getCoords().y;
    return R;
  }
  
  Point multiply(float k)
  {
    Point R = new Point();
    R.x = x*k;
    R.y = y*k;
    return R;
  }
  
  Point multiply(float k, float j)
  {
    Point R = new Point();
    R.x = x*k;
    R.y = y*j;
    return R;
  }
  
  Point rotatePoint(float r)
  {
    Point R = new Point();
    float xprev = x;
    float yprev = y;
    
    R.x = cos(r)*xprev+sin(r)*yprev;
    R.y = -sin(r)*xprev+cos(r)*yprev;
    return R;
  }
}
