class Stabilizer
{
  float[] array;
  
  Stabilizer(int PoolLength)
  {
    array = new float[PoolLength];
    for (int i=0; i<array.length; i++)
    {
      array[i] = 0;
    }
  }
  
  void update(float value)
  {
    array = pushUp();
    array[0] = value;
  }
  
  float[] pushUp()
  {
    float[] R = new float[array.length];
    R[0] = 0;
    
    for(int i=1; i<array.length; i++)
    {
      R[i] = array[i-1];
    }
    
    return R;
  }
  
  float value()
  {
    float total = 0;
    for (int i=0; i<array.length; i++)
    {
      total += array[i];
    }
    return total/array.length;
  }
}
